import { Headers, Request, ResponseOptions } from '@angular/http';
/**
 * Base class for implementing a request handler
 */
export declare abstract class AngularApiHandlerRequestHandler {
    /**
     * default response headers
     *
     * @type {Headers}
     */
    protected headers: Headers;
    /**
     * URL pattern match for selecting this handler
     */
    abstract matchingUrlsRegex: [{
        url: string;
        data?: any;
    }];
    /**
     * enable this individual handler
     */
    private enabled;
    constructor(enabled?: boolean);
    get(req: Request, index: number): ResponseOptions;
    post(req: Request, index: number): ResponseOptions;
    put(req: Request, index: number): ResponseOptions;
    delete(req: Request, index: number): ResponseOptions;
    isMatching(url: string): number;
    protected clone(data: any): any;
    protected defaultSuccessReponse(index: number): ResponseOptions;
    protected successResponse(data: Object): ResponseOptions;
    errorResponse(status: number, message: string): ResponseOptions;
}
