import { Headers, ResponseOptions } from '@angular/http';
import { STATUS } from './http-status-codes';
/**
 * Base class for implementing a request handler
 */
export var AngularApiHandlerRequestHandler = (function () {
    function AngularApiHandlerRequestHandler(enabled) {
        if (enabled === void 0) { enabled = true; }
        /**
         * default response headers
         *
         * @type {Headers}
         */
        this.headers = new Headers({ 'Content-Type': 'application/json' });
        this.enabled = enabled;
    }
    ;
    //////// request handlers ////////
    AngularApiHandlerRequestHandler.prototype.get = function (req, index) {
        return this.defaultSuccessReponse(index);
    };
    AngularApiHandlerRequestHandler.prototype.post = function (req, index) {
        return this.defaultSuccessReponse(index);
    };
    AngularApiHandlerRequestHandler.prototype.put = function (req, index) {
        return this.defaultSuccessReponse(index);
    };
    AngularApiHandlerRequestHandler.prototype.delete = function (req, index) {
        return this.defaultSuccessReponse(index);
    };
    AngularApiHandlerRequestHandler.prototype.isMatching = function (url) {
        if (this.enabled) {
            for (var i = 0; i < this.matchingUrlsRegex.length; i++) {
                if (new RegExp(this.matchingUrlsRegex[i].url).test(url)) {
                    return i;
                }
            }
        }
        return -1;
    };
    AngularApiHandlerRequestHandler.prototype.clone = function (data) {
        return JSON.parse(JSON.stringify(data));
    };
    AngularApiHandlerRequestHandler.prototype.defaultSuccessReponse = function (index) {
        if (this.matchingUrlsRegex[index].data !== null) {
            return this.successResponse(this.matchingUrlsRegex[index].data);
        }
        return this.successResponse({});
    };
    AngularApiHandlerRequestHandler.prototype.successResponse = function (data) {
        return new ResponseOptions({
            body: this.clone(data),
            headers: this.headers,
            status: STATUS.OK
        });
    };
    AngularApiHandlerRequestHandler.prototype.errorResponse = function (status, message) {
        return new ResponseOptions({
            body: { 'error': "" + message },
            headers: new Headers({ 'Content-Type': 'application/json' }),
            status: status
        });
    };
    return AngularApiHandlerRequestHandler;
}());
//# sourceMappingURL=angular-api-handler.request-handler.js.map